package edu.kit.ipd.descartes.adaptation.evaluation.performance;

import edu.kit.ipd.descartes.mm.adaptation.Objective;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;

/**
 * Evaluates a tactic.
 * 
 * @author nhuber
 * 
 */
public interface IEvaluator {

    /**
     * Evaluates the impact of a {@link WeightedTactic}.
     * 
     * @param tactic
     *            The weighted tactic to evaluate
     */
    public void evaluate(WeightedTactic tactic);

    /**
     * Checks if any QoS property has degraded significantly, i.e. any {@link Objective}has been
     * violated, after applying the tactic.
     * 
     * @param tactic
     * @return
     */
    public boolean slaViolated(WeightedTactic tactic);

    /**
     * Reduces the weight of the given tactic.
     * 
     * @param tactic
     */
    public void punishTactic(WeightedTactic tactic);

}
