package edu.kit.ipd.descartes.adaptation.evaluation.performance.weightingfunction;

import edu.kit.ipd.descartes.mm.adaptation.Tactic;
import edu.kit.ipd.descartes.mm.adaptation.WeightedMetric;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;
import edu.kit.ipd.descartes.mm.adaptation.WeightingFunction;

/**
 * @author nhuber
 *
 */
public interface IWeightingFunction {
	
    
    /**
     * Sets the {@link WeightingFunction} that can be used
     * by the {@link WeightingFunction} to derive the 
     * {@link WeightedMetric}s used to calculate the weight.
     * 
     * @param function
     */
    void setWeightingFunction(WeightingFunction function);
    
    /**
	 * Calculates the new weight of the given {@link Tactic}.
	 * 
	 * @param impact
	 * @return
	 */
    double calculateWeight(WeightedTactic weightedTactic);


}
