package edu.kit.ipd.descartes.adaptation.model.analysis.pcm;

import org.apache.log4j.Logger;

import edu.kit.ipd.descartes.adaptation.evaluation.performance.repository.IPerformanceDataRepositoryHandler;
import edu.kit.ipd.descartes.adaptation.evaluation.performance.repository.ObservationRepositoryHelper;
import edu.kit.ipd.descartes.adaptation.evaluation.performance.repository.PerfDataRepoConverter;
import edu.kit.ipd.descartes.adaptation.model.adaptation.dmm.BlueYonderExperimentTracker;
import edu.kit.ipd.descartes.adaptation.model.analysis.IModelAnalyzer;
import edu.kit.ipd.descartes.adaptation.model.dmm.DmlModelLoader;
import edu.kit.ipd.descartes.perfdatarepo.Impact;
import edu.kit.ipd.descartes.ql.models.repository.ObservationRepository;

public class PcmModelAnalyzer /*extends SimuComWorkflowLauncher*/ implements IModelAnalyzer {
	
	private static Logger logger = Logger.getLogger(PcmModelAnalyzer.class);
	private IPerformanceDataRepositoryHandler perfDataRepoHandler = null;

	public PcmModelAnalyzer(IPerformanceDataRepositoryHandler perfDataRepoHandler) {
        this.perfDataRepoHandler = perfDataRepoHandler;
    }

    @Override
	public void analyze() {
		logger.error("Model analyzation has not been implemented yet!");
		//TODO generate dummy results
	}

    @Override
    public Impact getLatestImpact() {
        
    	// TODO: Diese Prfung ist (noch) erforderlich weil fr BY eine etwas andere Struktur 
    	// im PerformanceDataRepository verwendet wird
    	if( ((ObservationRepository) perfDataRepoHandler.getRepository()).getIdentifier().contains("BlueYonder") ){
    		String expName = BlueYonderExperimentTracker.getInstance().getExperimentNameForDistributedDataCenter(DmlModelLoader.getDistributedDataCenter());
            logger.debug("Searching for impact of " + expName);
            Impact latestImpact = PerfDataRepoConverter.convertObservableImpact(ObservationRepositoryHelper
                    .searchImpactOfTactic(expName, (ObservationRepository) perfDataRepoHandler.getRepository()));
            return latestImpact;
    	} else {
    		return perfDataRepoHandler.getLatestImpact();
    	}
    }

}
