package edu.kit.ipd.descartes.adaptation.ql;

import java.util.List;

import org.apache.log4j.Logger;

import edu.kit.ipd.descartes.perfdatarepo.MetricType;
import edu.kit.ipd.descartes.ql.core.engine.query.QueryExecutionEngine;
import edu.kit.ipd.descartes.ql.core.engine.query.QueryExecutionEngineImpl;
import edu.kit.ipd.descartes.ql.models.mapping.mapping.EntityMapping;

public class QueryEngineAdapter {

    private static Logger logger = Logger.getLogger(QueryEngineAdapter.class);
    private QueryExecutionEngine qee = new QueryExecutionEngineImpl();
    private String pdrLocation = null;

    public QueryEngineAdapter(String pdrLocation) {
        this.pdrLocation = pdrLocation;
    }

    public int queryActiveServers() {
        String query = "LIST RESOURCES USING pdr@'" + pdrLocation + "';";
        List<EntityMapping> results = qee.execute(query);
        return results.size();
    }

    public Double getValueForMetricType(MetricType metricType) {
        // String pdrLocation = "/edu.kit.ipd.descartes.ql.lang.examples/PDR/optimizationTest.pdr";
        // String pdrLocation = "/by_dmm-model/optimizationTest.pdr";
        String query = "SELECT desc1." + metricType.getName() + " FOR RESOURCE '_uZslUK8HEeGqG9wdcmTqrg' AS desc1 "
                + "USING pdr@'" + pdrLocation + "';";

        logger.debug("Query: " + query);
        List<EntityMapping> results = qee.execute(query);

        if (!qee.isValidQuery()) {
            return Double.NaN;
        }

        for (EntityMapping result : results) {
            logger.debug(result);
        }

        return null;
    }
}
